include \masm32\include\masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	hLV	HWND	?
	psz	PCHAR	?
WND_DATA ends

.data?
	hInstance HINSTANCE ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	invoke InitCommonControls

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

LVSubClass proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL pOrgWndProc:PVOID
LOCAL lvi:LV_ITEM
	
	mov pOrgWndProc,rv(GetProp,hWnd,"pOrgWndProc")
	.if uMsg == WM_DESTROY
		invoke SetFocus,rv(GetParent,hWnd)		
		fn RemoveProp,hWnd,"pOrgWndProc"
		invoke CallWindowProc,pOrgWndProc,hWnd,uMsg,wParam,lParam
		ret
	.elseif uMsg == WM_WINDOWPOSCHANGING || (uMsg == WM_KEYDOWN && (wParam == VK_ESCAPE || wParam == VK_RETURN || wParam == VK_SPACE))
		.if SDWORD ptr rv(SendMessage,hWnd,LVM_GETNEXTITEM,-1,LVNI_SELECTED) >= 0
			mov lvi.iItem,eax
			mov lvi.iSubItem,0
			mov ebx,rv(GetParent,hWnd)
			mov edi,alloc(128)
			mov lvi.imask,LVIF_TEXT
			mov lvi.cchTextMax,128
			mov lvi.pszText,edi
			invoke SendMessage,hWnd,LVM_GETITEM,0,ADDR lvi
			invoke SendMessage,ebx,WM_USER+1,0,edi
		.endif
		invoke DestroyWindow,hWnd
	.else
		invoke CallWindowProc,pOrgWndProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	
	xor eax,eax
	ret
	
LVSubClass endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL clmn:LV_COLUMN
LOCAL lvi:LV_ITEM
LOCAL pt:POINT
LOCAL rect:RECT
LOCAL ps:PAINTSTRUCT
LOCAL sz[256]:CHAR

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		.if rv(GetWindowLong,hWnd,WND_DATA.psz)
			free eax
		.endif
	.elseif uMsg == WM_USER+1
		.if rv(GetWindowLong,hWnd,WND_DATA.psz)
			free eax
		.endif
		invoke SetWindowLong,hWnd,WND_DATA.psz,lParam
		invoke InvalidateRect,hWnd,0,0
	.elseif uMsg == WM_RBUTTONUP

		movzx ecx,WORD ptr lParam
		movzx edx,WORD ptr lParam[2]
		lea ecx,[ecx-300]
		mov pt.x,ecx
		mov pt.y,edx
		
		invoke ClientToScreen,hWnd,ADDR pt
		mov edi,rv(CreateWindowEx,0,"SysListView32",0,WS_POPUP or WS_VISIBLE or WS_BORDER or LVS_REPORT or LVS_SINGLESEL,pt.x,pt.y,300,300,hWnd,0,0,0)
		invoke SetWindowLong,hWnd,WND_DATA.hLV,edi
		invoke SendMessage,edi,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT
		
		invoke RtlZeroMemory,ADDR clmn,SIZEOF clmn
		mov clmn.imask,LVCF_TEXT or LVCF_WIDTH
		mov clmn.pszText,chr$("xyz")
		mov clmn.lx,200
		invoke SendMessage,edi,LVM_INSERTCOLUMN,0,ADDR clmn
		
		invoke RtlZeroMemory,ADDR lvi,SIZEOF lvi
		mov lvi.imask,LVIF_TEXT
		mov lvi.pszText,chr$("1234")
		invoke SendMessage,edi,LVM_INSERTITEM,0,ADDR lvi
		
		mov lvi.pszText,chr$("567")
		invoke SendMessage,edi,LVM_INSERTITEM,0,ADDR lvi
		
		mov lvi.pszText,chr$("89")
		invoke SendMessage,edi,LVM_INSERTITEM,0,ADDR lvi
		
		fn SetProp,edi,"pOrgWndProc",rv(GetWindowLong,edi,GWL_WNDPROC)
		invoke SetWindowLong,edi,GWL_WNDPROC,LVSubClass
		
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		invoke GetClientRect,hWnd,ADDR rect
		invoke BitBlt,ps.hdc,0,0,rect.right,rect.bottom,ps.hdc,0,0,PATPAINT
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.psz)
		mov sz[0],0
		.if ebx
			strcat ADDR sz,"right click to open LV, last result: ",ebx
		.else
			strcat ADDR sz,"right click to open LV"
		.endif
		fn DrawText,ps.hdc,ADDR sz,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER
		invoke EndPaint,hWnd,ADDR ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

end main
